
var gPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

function embConciseMode()
{
   const OPEN_SIDEBAR = 2;

// Check window title for an extension count
// Done first because it's a quick way to see if this handler has already been executed
// Need to do it two ways because of changes in Firefox 1.1
   var oldTitle = document.getElementById("extensionsManager").getAttribute("title");
   if (!oldTitle) oldTitle = window.title;

// If the count has already been appended to the title
// this must be the second instance of the handler and can exit now
   var countPos = oldTitle.indexOf("[");
   if (countPos != -1) return;

// Get all the prefs required to decide which changes to make to the display
   try {
      var openinPref = gPref.getIntPref("extensions.embuttons.extensionsTarget");
      var conciseMode = gPref.getBoolPref("extensions.embuttons.conciseModeEM");
      var perfMode = gPref.getBoolPref("extensions.embuttons.perfModeEM");
      var extCount = gPref.getIntPref("extensions.embuttons.count.extension");
   } catch(e){
      if (openinPref == undefined) openinPref = OPEN_SIDEBAR;
      if (conciseMode == undefined) conciseMode = false;
      if (perfMode == undefined) perfMode = false;
      if (extCount == undefined) extCount = e;
   }

   var embSidebar = (openinPref == OPEN_SIDEBAR)? true : false;

// Append the extension count to the window title
// Need to do it two ways because of changes in Firefox 1.1
   document.getElementById("extensionsManager").setAttribute("title",oldTitle + " [" + extCount + "]");
   window.title = oldTitle + " [" + extCount + "]";

// Set or clear Concise Mode and Performance Mode

   const XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
   var els = document.getElementsByTagNameNS(XULNS,"extension");
   var i;
   for (i = 0; i < els.length; ++i) {
      els[i].setAttribute("embconcisemode", conciseMode);
      els[i].setAttribute("embperfmode", perfMode);
   }
   document.getElementById("getMore").setAttribute("embconcisemode", embSidebar);
   document.getElementById("extensionsView").setAttribute("embconcisemode", conciseMode);
   document.getElementById("extensionsView").setAttribute("embperfmode", perfMode);

   try {
      // Set attribute for the CSS to hide (if opened in the sidebar) or show the Options button.
      document.getElementById("optionsButton").setAttribute("embsidebar", embSidebar);
   } catch(e){
      // This button didn't exist before the Firefox 1.0PR nightlies, so I need to trap the potential error.
      // Thanks to jooliaan for spotting the bug in 0.12.0
   }
}
